#ifndef __ECLIENTMESSAGETYPE__H__
#define __ECLIENTMESSAGETYPE__H__

#include <cstdint>

enum class eClientMessageType : uint32_t {
	LOGIN_RESPONSE = 0,
	LOGOUT_RESPONSE,
	LOAD_STATIC_ZONE,
	CREATE_OBJECT,
	CREATE_CHARACTER,
	CREATE_CHARACTER_EXTENDED,
	CHARACTER_LIST_RESPONSE,
	CHARACTER_CREATE_RESPONSE,
	CHARACTER_RENAME_RESPONSE,
	CHAT_CONNECT_RESPONSE,
	AUTH_ACCOUNT_CREATE_RESPONSE,
	DELETE_CHARACTER_RESPONSE,
	GAME_MSG,
	CONNECT_CHAT,
	TRANSFER_TO_WORLD,
	IMPENDING_RELOAD_NOTIFY,
	MAKE_GM_RESPONSE,
	HTTP_MONITOR_INFO_RESPONSE,
	SLASH_PUSH_MAP_RESPONSE,
	SLASH_PULL_MAP_RESPONSE,
	SLASH_LOCK_MAP_RESPONSE,
	BLUEPRINT_SAVE_RESPONSE,
	BLUEPRINT_LUP_SAVE_RESPONSE,
	BLUEPRINT_LOAD_RESPONSE_ITEMID,
	BLUEPRINT_GET_ALL_DATA_RESPONSE,
	MODEL_INSTANTIATE_RESPONSE,
	DEBUG_OUTPUT,
	ADD_FRIEND_REQUEST,
	ADD_FRIEND_RESPONSE,
	REMOVE_FRIEND_RESPONSE,
	GET_FRIENDS_LIST_RESPONSE,
	UPDATE_FRIEND_NOTIFY,
	ADD_IGNORE_RESPONSE,
	REMOVE_IGNORE_RESPONSE,
	GET_IGNORE_LIST_RESPONSE,
	TEAM_INVITE,
	TEAM_INVITE_INITIAL_RESPONSE,
	GUILD_CREATE_RESPONSE,
	GUILD_GET_STATUS_RESPONSE,
	GUILD_INVITE,
	GUILD_INVITE_INITIAL_RESPONSE,
	GUILD_INVITE_FINAL_RESPONSE,
	GUILD_INVITE_CONFIRM,
	GUILD_ADD_PLAYER,
	GUILD_REMOVE_PLAYER,
	GUILD_LOGIN_LOGOUT,
	GUILD_RANK_CHANGE,
	GUILD_DATA,
	GUILD_STATUS,
	MAIL,
	DB_PROXY_RESULT,
	SHOW_ALL_RESPONSE,
	WHO_RESPONSE,
	SEND_CANNED_TEXT,
	UPDATE_CHARACTER_NAME,
	SET_NETWORK_SIMULATOR,
	INVALID_CHAT_MESSAGE,
	MINIMUM_CHAT_MODE_RESPONSE,
	MINIMUM_CHAT_MODE_RESPONSE_PRIVATE,
	CHAT_MODERATION_STRING,
	UGC_MANIFEST_RESPONSE,
	IN_LOGIN_QUEUE,
	SERVER_STATES,
	GM_CLOSE_TARGET_CHAT_WINDOW,
	GENERAL_TEXT_FOR_LOCALIZATION,
	UPDATE_FREE_TRIAL_STATUS,
	UGC_DOWNLOAD_FAILED = 120
};

#endif  //!__ECLIENTMESSAGETYPE__H__
