#ifndef __EGAMEMESSAGETYPE__H__
#define __EGAMEMESSAGETYPE__H__

#include <cstdint>

enum class eGameMessageType : uint16_t {
	TELEPORT = 19,
	SET_PLAYER_CONTROL_SCHEME = 26,
	DROP_CLIENT_LOOT = 30,
	DIE = 37,
	REQUEST_DIE = 38,
	PLAY_EMOTE = 41,
	PLAY_ANIMATION = 43,
	CONTROL_BEHAVIOR = 48,
	SET_NAME = 72,
	ECHO_START_SKILL = 118,
	START_SKILL = 119,
	VERIFY_ACK = 121,
	ADD_SKILL = 127,
	REMOVE_SKILL = 128,
	SET_CURRENCY = 133,
	PICKUP_CURRENCY = 137,
	PICKUP_ITEM = 139,
	TEAM_PICKUP_ITEM = 140,
	PLAY_FX_EFFECT = 154,
	STOP_FX_EFFECT = 155,
	REQUEST_RESURRECT = 159,
	RESURRECT = 160,
	PUSH_EQUIPPED_ITEMS_STATE = 191,
	POP_EQUIPPED_ITEMS_STATE = 192,
	SET_GM_LEVEL = 193,
	SET_STUNNED = 198,
	SET_STUN_IMMUNITY = 200,
	KNOCKBACK = 202,
	REBUILD_CANCEL = 209,
	ENABLE_REBUILD = 213,
	MOVE_ITEM_IN_INVENTORY = 224,
	ADD_ITEM_TO_INVENTORY_CLIENT_SYNC = 227,
	REMOVE_ITEM_FROM_INVENTORY = 230,
	EQUIP_ITEM = 231,
	UN_EQUIP_ITEM = 233,
	OFFER_MISSION = 248,
	RESPOND_TO_MISSION = 249,
	NOTIFY_MISSION = 254,
	NOTIFY_MISSION_TASK = 255,
	REBUILD_NOTIFY_STATE = 336,
	TERMINATE_INTERACTION = 357,
	SERVER_TERMINATE_INTERACTION = 358,
	REQUEST_USE = 364,
	VENDOR_OPEN_WINDOW = 369,
	BUY_FROM_VENDOR = 373,
	SELL_TO_VENDOR = 374,
	TEAM_SET_OFF_WORLD_FLAG = 383,
	SET_INVENTORY_SIZE = 389,
	ACKNOWLEDGE_POSSESSION = 391,
	SET_SHOOTING_GALLERY_PARAMS = 400,
	REQUEST_ACTIVITY_START_STOP = 402,
	REQUEST_ACTIVITY_ENTER = 403,
	REQUEST_ACTIVITY_EXIT = 404,
	ACTIVITY_ENTER = 405,
	ACTIVITY_EXIT = 406,
	ACTIVITY_START = 407,
	ACTIVITY_STOP = 408,
	SHOOTING_GALLERY_CLIENT_AIM_UPDATE = 409,
	SHOOTING_GALLERY_FIRE = 411,
	REQUEST_VENDOR_STATUS_UPDATE = 416,
	VENDOR_STATUS_UPDATE = 417,
	NOTIFY_CLIENT_SHOOTING_GALLERY_SCORE = 425,
	CONSUME_CLIENT_ITEM = 427,
	CLIENT_ITEM_CONSUMED = 428,
	UPDATE_SHOOTING_GALLERY_ROTATION = 448,
	SET_FLAG = 471,
	NOTIFY_CLIENT_FLAG_CHANGE = 472,
	VENDOR_TRANSACTION_RESULT = 476,
	HAS_BEEN_COLLECTED = 486,
	DISPLAY_CHAT_BUBBLE = 495,
	SPAWN_PET = 498,
	DESPAWN_PET = 499,
	PLAYER_LOADED = 505,
	PLAYER_READY = 509,
	REQUEST_LINKED_MISSION = 515,
	INVALID_ZONE_TRANSFER_LIST = 519,
	MISSION_DIALOGUE_OK = 520,
	DISPLAY_MESSAGE_BOX = 529,
	MESSAGE_BOX_RESPOND = 530,
	CHOICE_BOX_RESPOND = 531,
	SMASH = 537,
	UNSMASH = 538,
	PLACE_MODEL_RESPONSE = 547,
	SET_SHOOTING_GALLERY_RETICULE_EFFECT = 548,
	SET_JET_PACK_MODE = 561,
	REGISTER_PET_ID = 565,
	REGISTER_PET_DBID = 566,
	SHOW_ACTIVITY_COUNTDOWN = 568,
	START_ACTIVITY_TIME = 576,
	ACTIVITY_PAUSE = 602,
	USE_NON_EQUIPMENT_ITEM = 603,
	USE_ITEM_RESULT = 607,
	COMMAND_PET = 640,
	PET_RESPONSE = 641,
	REQUEST_ACTIVITY_SUMMARY_LEADERBOARD_DATA = 648,
	SEND_ACTIVITY_SUMMARY_LEADERBOARD_DATA = 649,
	NOTIFY_OBJECT = 656,
	CLIENT_NOTIFY_PET = 659,
	NOTIFY_PET = 660,
	NOTIFY_PET_TAMING_MINIGAME = 661,
	START_SERVER_PET_MINIGAME_TIMER = 662,
	CLIENT_EXIT_TAMING_MINIGAME = 663,
	PET_NAME_CHANGED = 686,
	PET_TAMING_MINIGAME_RESULT = 667,
	PET_TAMING_TRY_BUILD_RESULT = 668,
	NOTIFY_TAMING_BUILD_SUCCESS = 673,
	NOTIFY_TAMING_MODEL_LOADED_ON_SERVER = 674,
	ACTIVATE_BUBBLE_BUFF = 678,
	DEACTIVATE_BUBBLE_BUFF = 679,
	ADD_PET_TO_PLAYER = 681,
	REQUEST_SET_PET_NAME = 683,
	SET_PET_NAME = 684,
	NOTIFY_PET_TAMING_PUZZLE_SELECTED = 675,
	SHOW_PET_ACTION_BUTTON = 692,
	SET_EMOTE_LOCK_STATE = 693,
	USE_ITEM_REQUIREMENTS_RESPONSE = 703,
	PLAY_EMBEDDED_EFFECT_ON_ALL_CLIENTS_NEAR_OBJECT = 713,
	DOWNLOAD_PROPERTY_DATA = 716,
	QUERY_PROPERTY_DATA = 717,
	PROPERTY_EDITOR_BEGIN = 724,
	PROPERTY_EDITOR_END = 725,
	IS_MINIFIG_IN_A_BUBBLE = 729,
	START_PATHING = 733,
	ACTIVATE_BUBBLE_BUFF_FROM_SERVER = 734,
	DEACTIVATE_BUBBLE_BUFF_FROM_SERVER = 735,
	NOTIFY_CLIENT_ZONE_OBJECT = 737,
	UPDATE_REPUTATION = 746,
	PROPERTY_RENTAL_RESPONSE = 750,
	REQUEST_PLATFORM_RESYNC = 760,
	PLATFORM_RESYNC = 761,
	PLAY_CINEMATIC = 762,
	END_CINEMATIC = 763,
	CINEMATIC_UPDATE = 764,
	TOGGLE_GHOST_REFERENCE_OVERRIDE = 767,
	SET_GHOST_REFERENCE_POSITION = 768,
	FIRE_EVENT_SERVER_SIDE = 770,
	SET_NETWORK_SCRIPT_VAR = 781,
	UPDATE_MODEL_FROM_CLIENT = 793,
	DELETE_MODEL_FROM_CLIENT = 794,
	PLAY_ND_AUDIO_EMITTER = 821,
	PLAY2_DAMBIENT_SOUND = 831,
	ENTER_PROPERTY1 = 840,
	ENTER_PROPERTY2 = 841,
	PROPERTY_ENTRANCE_SYNC = 842,
	PROPERTY_SELECT_QUERY = 845,
	PARSE_CHAT_MESSAGE = 850,
	BROADCAST_TEXT_TO_CHATBOX = 858,
	OPEN_PROPERTY_MANAGEMENT = 860,
	OPEN_PROPERTY_VENDOR = 861,
	UPDATE_PROPERTY_OR_MODEL_FOR_FILTER_CHECK = 863,
	CLIENT_TRADE_REQUEST = 868,
	SERVER_TRADE_REQUEST = 869,
	SERVER_TRADE_INVITE = 870,
	CLIENT_TRADE_REPLY = 871,
	SERVER_TRADE_REPLY = 872,
	SERVER_TRADE_INITIAL_REPLY = 873,
	SERVER_TRADE_FINAL_REPLY = 874,
	CLIENT_TRADE_UPDATE = 875,
	SERVER_SIDE_TRADE_UPDATE = 876,
	SERVER_TRADE_UPDATE = 877,
	CLIENT_TRADE_CANCEL = 878,
	CLIENT_SIDE_TRADE_CANCEL = 879,
	CLIENT_TRADE_ACCEPT = 880,
	SERVER_SIDE_TRADE_ACCEPT = 881,
	SERVER_SIDE_TRADE_CANCEL = 882,
	SERVER_TRADE_CANCEL = 883,
	SERVER_TRADE_ACCEPT = 884,
	READY_FOR_UPDATES = 888,
	ORIENT_TO_OBJECT = 905,
	ORIENT_TO_POSITION = 906,
	ORIENT_TO_ANGLE = 907,
	BOUNCER_ACTIVE_STATUS = 942,
	UN_USE_BBB_MODEL = 999,
	BBB_LOAD_ITEM_REQUEST = 1000,
	BBB_SAVE_REQUEST = 1001,
	BBB_SAVE_RESPONSE = 1006,
	NOTIFY_CLIENT_OBJECT = 1042,
	DISPLAY_ZONE_SUMMARY = 1043,
	ZONE_SUMMARY_DISMISSED = 1044,
	ACTIVITY_STATE_CHANGE_REQUEST = 1053,
	MODIFY_PLAYER_ZONE_STATISTIC = 1046,
	START_BUILDING_WITH_ITEM = 1057,
	START_ARRANGING_WITH_ITEM = 1061,
	FINISH_ARRANGING_WITH_ITEM = 1062,
	DONE_ARRANGING_WITH_ITEM = 1063,
	SET_BUILD_MODE = 1068,
	BUILD_MODE_SET = 1069,
	SET_BUILD_MODE_CONFIRMED = 1073,
	NOTIFY_CLIENT_FAILED_PRECONDITION = 1081,
	MOVE_ITEM_BETWEEN_INVENTORY_TYPES = 1093,
	MODULAR_BUILD_BEGIN = 1094,
	MODULAR_BUILD_END = 1095,
	MODULAR_BUILD_MOVE_AND_EQUIP = 1096,
	MODULAR_BUILD_FINISH = 1097,
	REPORT_BUG = 1198,
	MISSION_DIALOGUE_CANCELLED = 1129,
	ECHO_SYNC_SKILL = 1144,
	SYNC_SKILL = 1145,
	REQUEST_SERVER_PROJECTILE_IMPACT = 1148,
	DO_CLIENT_PROJECTILE_IMPACT = 1151,
	MODULAR_BUILD_CONVERT_MODEL = 1155,
	SET_PLAYER_ALLOWED_RESPAWN = 1165,
	UI_MESSAGE_SERVER_TO_SINGLE_CLIENT = 1184,
	UI_MESSAGE_SERVER_TO_ALL_CLIENTS = 1185,
	PET_TAMING_TRY_BUILD = 1197,
	REQUEST_SMASH_PLAYER = 1202,
	FIRE_EVENT_CLIENT_SIDE = 1213,
	TOGGLE_GM_INVIS = 1218,
	CHANGE_OBJECT_WORLD_STATE = 1223,
	VEHICLE_LOCK_INPUT = 1230,
	VEHICLE_UNLOCK_INPUT = 1231,
	RACING_RESET_PLAYER_TO_LAST_RESET = 1252,
	RACING_SERVER_SET_PLAYER_LAP_AND_PLANE = 1253,
	RACING_SET_PLAYER_RESET_INFO = 1254,
	RACING_PLAYER_INFO_RESET_FINISHED = 1255,
	LOCK_NODE_ROTATION = 1260,
	VEHICLE_SET_WHEEL_LOCK_STATE = 1273,
	NOTIFY_VEHICLE_OF_RACING_OBJECT = 1276,
	SET_NAME_BILLBOARD_STATE = 1284,
	PLAYER_REACHED_RESPAWN_CHECKPOINT = 1296,
	HANDLE_UGC_EQUIP_POST_DELETE_BASED_ON_EDIT_MODE = 1300,
	HANDLE_UGC_EQUIP_PRE_CREATE_BASED_ON_EDIT_MODE = 1301,
	PROPERTY_CONTENTS_FROM_CLIENT = 1305,
	GET_MODELS_ON_PROPERTY = 1306,
	MATCH_REQUEST = 1308,
	MATCH_RESPONSE = 1309,
	MATCH_UPDATE = 1310,
	MODULE_ASSEMBLY_DB_DATA_FOR_CLIENT = 1131,
	MODULE_ASSEMBLY_QUERY_DATA = 1132,
	SHOW_BILLBOARD_INTERACT_ICON = 1337,
	CHANGE_IDLE_FLAGS = 1338,
	VEHICLE_ADD_PASSIVE_BOOST_ACTION = 1340,
	VEHICLE_REMOVE_PASSIVE_BOOST_ACTION = 1341,
	VEHICLE_NOTIFY_SERVER_ADD_PASSIVE_BOOST_ACTION = 1342,
	VEHICLE_NOTIFY_SERVER_REMOVE_PASSIVE_BOOST_ACTION = 1343,
	VEHICLE_ADD_SLOWDOWN_ACTION = 1344,
	VEHICLE_REMOVE_SLOWDOWN_ACTION = 1345,
	VEHICLE_NOTIFY_SERVER_ADD_SLOWDOWN_ACTION = 1346,
	VEHICLE_NOTIFY_SERVER_REMOVE_SLOWDOWN_ACTION = 1347,
	BUYBACK_FROM_VENDOR = 1350,
	SET_PROPERTY_ACCESS = 1366,
	ZONE_PROPERTY_MODEL_PLACED = 1369,
	ZONE_PROPERTY_MODEL_ROTATED = 1370,
	ZONE_PROPERTY_MODEL_REMOVED_WHILE_EQUIPPED = 1371,
	ZONE_PROPERTY_MODEL_EQUIPPED = 1372,
	ZONE_PROPERTY_MODEL_PICKED_UP = 1373,
	ZONE_PROPERTY_MODEL_REMOVED = 1374,
	NOTIFY_RACING_CLIENT = 1390,
	RACING_PLAYER_HACK_CAR = 1391,
	RACING_PLAYER_LOADED = 1392,
	RACING_CLIENT_READY = 1393,
	UPDATE_CHAT_MODE = 1395,
	VEHICLE_NOTIFY_FINISHED_RACE = 1396,
	SET_CONSUMABLE_ITEM = 1409,
	SET_STATUS_IMMUNITY = 1435,
	SET_PET_NAME_MODERATED = 1448,
	MODIFY_LEGO_SCORE = 1459,
	RESTORE_TO_POST_LOAD_STATS = 1468,
	SET_RAIL_MOVEMENT = 1471,
	START_RAIL_MOVEMENT = 1472,
	CANCEL_RAIL_MOVEMENT = 1474,
	CLIENT_RAIL_MOVEMENT_READY = 1476,
	PLAYER_RAIL_ARRIVED_NOTIFICATION = 1477,
	UPDATE_PLAYER_STATISTIC = 1481,
	MODULAR_ASSEMBLY_NIF_COMPLETED = 1498,
	NOTIFY_NOT_ENOUGH_INV_SPACE = 1516,
	TEAM_SET_LEADER = 1557,
	TEAM_INVITE_CONFIRM = 1558,
	TEAM_GET_STATUS_RESPONSE = 1559,
	TEAM_ADD_PLAYER = 1562,
	TEAM_REMOVE_PLAYER = 1563,
	START_CELEBRATION_EFFECT = 1618,
	ADD_BUFF = 1647,
	SERVER_DONE_LOADING_ALL_OBJECTS = 1642,
	PLACE_PROPERTY_MODEL = 1170,
	VEHICLE_NOTIFY_HIT_IMAGINATION_SERVER = 1606,
	ADD_RUN_SPEED_MODIFIER = 1505,
	HANDLE_HOT_PROPERTY_DATA = 1511,
	SEND_HOT_PROPERTY_DATA = 1510,
	REMOVE_RUN_SPEED_MODIFIER = 1506,
	UPDATE_PROPERTY_PERFORMANCE_COST = 1547,
	PROPERTY_ENTRANCE_BEGIN = 1553,
	SET_RESURRECT_RESTORE_VALUES = 1591,
	VEHICLE_STOP_BOOST = 1617,
	REMOVE_BUFF = 1648,
	REQUEST_MOVE_ITEM_BETWEEN_INVENTORY_TYPES = 1666,
	RESPONSE_MOVE_ITEM_BETWEEN_INVENTORY_TYPES = 1667,
	PLAYER_SET_CAMERA_CYCLING_MODE = 1676,
	SET_MOUNT_INVENTORY_ID = 1726,
	NOTIFY_SERVER_LEVEL_PROCESSING_COMPLETE = 1734,
	NOTIFY_LEVEL_REWARDS = 1735,
	DISMOUNT_COMPLETE = 1756,
	MARK_INVENTORY_ITEM_AS_ACTIVE = 1767,
	END
};

#endif  //!__EGAMEMESSAGETYPE__H__
