#ifndef __EREPLICACOMPONENTTYPE__H__
#define __EREPLICACOMPONENTTYPE__H__

#include <cstdint>

enum class eReplicaComponentType : uint32_t {
	INVALID = 0,
	CONTROLLABLE_PHYSICS,
	RENDER,
	SIMPLE_PHYSICS,
	CHARACTER,
	SCRIPT,
	BOUNCER,
	DESTROYABLE,
	GHOST,
	SKILL,
	SPAWN,
	ITEM,
	MODULAR_BUILD,
	BUILD_CONTROLLER,
	BUILD_ACTIVATOR,
	ICON_ONLY,
	VENDOR,
	INVENTORY,
	PROJECTILE_PHYSICS,
	SHOOTING_GALLERY,
	RIGID_BODY_PHANTOM_PHYSICS,
	DROP_EFFECT,
	CHEST,
	COLLECTIBLE,
	BLUEPRINT,
	MOVING_PLATFORM,
	PET,
	PLATFORM_BOUNDARY,
	MODULE,
	JETPACKPAD,
	HAVOK_VEHICLE_PHYSICS,
	MOVEMENT_AI,
	EXHIBIT,
	OVERHEAD_ICON,
	PET_CONTROL,
	MINIFIG,
	PROPERTY,
	PET_CREATOR,
	MODEL_BUILDER,
	SCRIPTED_ACTIVITY,
	PHANTOM_PHYSICS,
	SPRINGPAD,
	MODEL_BEHAVIOR,
	PROPERTY_ENTRANCE,
	FX,
	PROPERTY_MANAGEMENT,
	VEHICLE_PHYSICS,
	PHYSICS_SYSTEM,
	QUICK_BUILD,
	SWITCH,
	MINIGAME_CONTROL,
	CHANGLING_BUILD,
	CHOICE_BUILD,
	PACKAGE,
	SOUND_REPEATER,
	SOUND_AMBIENT_2D,
	SOUND_AMBIENT_3D,
	PRECONDITION,
	FLAG,
	CUSTOM_BUILD_ASSEMBLY,
	BASE_COMBAT_AI,
	MODULE_ASSEMBLY,
	SHOWCASE_MODEL_HANDLER,
	RACING_MODULE,
	GENERIC_ACTIVATOR,
	PROPERTY_VENDOR,
	HF_LIGHT_DIRECTION_GADGET,
	ROCKET_LAUNCHPAD_CONTROL,
	ROCKET_ANIMATION_CONTROL,
	TRIGGER,
	DROPPED_LOOT,
	RACING_CONTROL,
	FACTION_TRIGGER,
	MISSION_OFFER,
	RACING_STATS,
	LUP_EXHIBIT,
	BBB,
	SOUND_TRIGGER,
	PROXIMITY_MONITOR,
	RACING_SOUND_TRIGGER,
	CHAT_BUBBLE,
	FRIENDS_LIST,
	GUILD,
	LOCAL_SYSTEM,
	MISSION,
	MUTABLE_MODEL_BEHAVIORS,
	PATHFINDING,
	PET_TAMING_CONTROL,
	PROPERTY_EDITOR,
	SKINNED_RENDER,
	SLASH_COMMAND,
	STATUS_EFFECT,
	TEAMS,
	TEXT_EFFECT,
	TRADE,
	USER_CONTROL,
	IGNORE_LIST,
	MULTI_ZONE_ENTRANCE,
	BUFF,
	INTERACTION_MANAGER,
	DONATION_VENDOR,
	COMBAT_MEDIATOR,
	ACHIEVEMENT_VENDOR,
	GATE_RUSH_CONTROL,
	RAIL_ACTIVATOR,
	ROLLER,
	PLAYER_FORCED_MOVEMENT,
	CRAFTING,
	POSSESSABLE,
	LEVEL_PROGRESSION,
	POSSESSOR,
	MOUNT_CONTROL,
	UNKNOWN_112,
	PROPERTY_PLAQUE,
	BUILD_BORDER,
	UNKNOWN_115,
	CULLING_PLANE,
	NUMBER_OF_COMPONENTS
};

#endif  //!__EREPLICACOMPONENTTYPE__H__
